Libargus API Libargus Camera API

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions
Argus::ICameraProvider Class Reference
CameraProvider

Interface to the core CameraProvider methods. More...

`#include <CameraProvider.h>`

Inheritance diagram for Argus::ICameraProvider:

List of all members.

## Public Member Functions

virtual const std::string & | getVersion () const =0
| Returns the version number of the libargus implementation.
virtual const std::string & | getVendor () const =0
| Returns the vendor string for the libargus implementation.
virtual bool | supportsExtension (const ExtensionName &extension) const =0
| Returns whether or not an extension is supported by this libargus implementation.
virtual Status | getCameraDevices (std::vector< CameraDevice * > *devices) const =0
| Returns the list of camera devices that are exposed by the provider.
virtual Status | setSyncSensorSessionsCount (uint32_t dualSensors, uint32_t singleSensor)=0
| Sets the number of sessions needed for dual and/or single sensors sync session usecase.
virtual CaptureSession * | createCaptureSession (CameraDevice *device, Status *status=NULL)=0
| Creates and returns a new CaptureSession using the given device.
virtual CaptureSession * | createCaptureSession (const std::vector< CameraDevice * > &devices, Status *status=NULL)=0
| Creates and returns a new CaptureSession using the given device(s).

## Static Public Member Functions

static const InterfaceID & | id ()

## Protected Member Functions

| ~ICameraProvider ()
Protected Member Functions inherited from Argus::Interface
| Interface ()
| ~Interface ()

## Detailed Description

Interface to the core CameraProvider methods.

Definition at line 77 of file CameraProvider.h.

## Constructor & Destructor Documentation

Argus::ICameraProvider::~ICameraProvider | ( |  | ) |

inline protected

Definition at line 149 of file CameraProvider.h.

## Member Function Documentation

virtual CaptureSession* Argus::ICameraProvider::createCaptureSession | ( | CameraDevice * | device,
|  | Status * | status = `NULL`
| ) |  |

pure virtual

Creates and returns a new CaptureSession using the given device.

STATUS_UNAVAILABLE will be placed into `status` if the device is already in use.

Parameters:

  [in] | device | The device to use for the CaptureSession.
  [out] | status | Optional pointer to return success/status of the call.

Returns:
  The new CaptureSession, or NULL if an error occurred.

virtual CaptureSession* Argus::ICameraProvider::createCaptureSession | ( | const std::vector< CameraDevice * > & | devices,
|  | Status * | status = `NULL`
| ) |  |

pure virtual

Creates and returns a new CaptureSession using the given device(s).

STATUS_UNAVAILABLE will be placed into `status` if any of the devices are already in use.

Parameters:

  [in] | devices | The device(s) to use for the CaptureSession.
  [out] | status | Optional pointer to return success/status of the call.

Returns:
  The new CaptureSession, or NULL if an error occurred.

virtual Status Argus::ICameraProvider::getCameraDevices | ( | std::vector< CameraDevice * > * | devices | ) | const

pure virtual

Returns the list of camera devices that are exposed by the provider.

This includes devices that may already be in use by active CaptureSessions, and it's the application's responsibility to check device availability and/or handle any errors returned when CaptureSession creation fails due to a device already being in use.

Parameters:

  [out] | devices | A vector that will be populated by the available devices.

Returns:
  success/status of the call.

virtual const std::string& Argus::ICameraProvider::getVendor | ( |  | ) | const

pure virtual

Returns the vendor string for the libargus implementation.

virtual const std::string& Argus::ICameraProvider::getVersion | ( |  | ) | const

pure virtual

Returns the version number of the libargus implementation.

This string will begin with the major and minor version numbers, separated by a period, and may be followed by any additional vendor-specific version information.

static const InterfaceID& Argus::ICameraProvider::id | ( |  | ) |

inline static

Definition at line 80 of file CameraProvider.h.

virtual Status Argus::ICameraProvider::setSyncSensorSessionsCount | ( | uint32_t | dualSensors,
|  | uint32_t | singleSensor
| ) |  |

pure virtual

Sets the number of sessions needed for dual and/or single sensors sync session usecase.

Parameters:

  [in] | dualSensors | Number of sessions needed for dual sync sensors.
  [in] | singleSensor | Number of sessions needed for single sync sensors.

Returns:
  success/status of the call.

virtual bool Argus::ICameraProvider::supportsExtension | ( | const ExtensionName & | extension | ) | const

pure virtual

Returns whether or not an extension is supported by this libargus implementation.

This is generally used during process initialization to ensure that all required extensions are present before initializing any CaptureSessions. Note, however, that having an extension be supported does not imply that the resources or devices required for that extension are available; standard interface checking and any other extension-specific runtime checks, as described by the extension documentation, should always be performed before any extension is used.

Parameters:

  [in] | extension | the extension identifier.

The documentation for this class was generated from the following file:

- include/Argus/CameraProvider.h